{ -------------------------------------------------------------------------- }
{ Berechnungen aus Montenbruck/Pfleger, Astronomie mit dem PC, Springerverl. }
{ Genauigkeit: mindestens 5 Bogensekunden !!!!                               }
{ -------------------------------------------------------------------------- }


{Neuste Version  }


{$N+,E+}       {Coprozessor verwenden, wenn nicht da emulieren !}
{$G-}          {Code erzeugen fuer 8086 CPU}


Program Astronomie;

  uses crt,dos,matlib, pnulib, sphlib, sunlib, p15lib, p69lib, moolib, timlib;

  VAR RA,DE,PAR, MODJD, HOUR,T          : extended;
      DAY,MONTH,YEAR                    : INTEGER;
      Fixbreite, Fixlaenge              : extended;
      ch                                : char;


  VAR  Hohe, dec, sternwinkel, aug, gisb,gisl,gb,hchc   : extended;
       HP, grtgrad, decgrad,ariesgrad, azimut           : extended;

       NAME        : ARRAY [1..80] OF STRING[50];
       WINKEL      : ARRAY [1..80] OF extended;
       DECli       : ARRAY [1..80] OF extended;

       datei                                            : TEXT;
       tag, monat, jahr,stu,min,sec                     : INTEGER;
       hauptmenu, esc, eini, positionberechnet          : BOOLEAN;
       planet                                           : STRING;

       TYPE  standlinie=RECORD
                          tag, monat, jahr : INTEGER;
                          h,m,s            : INTEGER;
                          Gestirn          : STRING;
                          laenge, breite   : EXTENDED;
                          Azimut, distanz  : EXTENDED;
                        END;

VAR    linienspeicher         : ARRAY [1..10] OF standlinie;
       standlinienzaehler     : INTEGER;



procedure escreadln (VAR amen:STRING);

VAR charon : CHAR;

BEGIN
  amen :='';
  REPEAT
    charon := READKEY;
    IF (charon <> chr(27)) AND (charon <> chr(13)) THEN BEGIN
                                                          WRITE (charon);
                                                          amen:=amen+charon;
                                                        END;
  UNTIL (charon=chr(27)) OR (charon=chr(13));
  IF charon = chr(13) THEN WRITELN;
  if charon = chr(27) THEN amen := chr(27);
END;


PROCEDURE eingabe (VAR ergebnis : string);
VAR lang : INTEGER;
    hier : BOOLEAN;

BEGIN
  ergebnis := '';
  REPEAT
    hier := false;
    ch := readkey;
    if ord(ch) > 31 THEN write (ch);
    if ord (ch) = 8 THEN BEGIN
                            hier := True;
                            GOTOXY (WHEREX-1, WHEREY); WRITE (' ');
                            gotoxy (WHEREX-1, WHEREY);
                            lang := LENGTH (ergebnis);
                            ergebnis := COPY (ergebnis,1,lang-1);
                          END;
    if ord(ch) > 31 THEN ergebnis := ergebnis + ch ;
  UNTIL (ch = chr(27)) OR (ch = chr(13));
  if ch = chr(27) THEN BEGIN
                         ESC := TRUE;
                         EXIT; EXIT;
                       END;
  WRITELN;
END;



PROCEDURE home (x,y : INTEGER);
VAR n : INTEGER;
BEGIN
  GOTOXY (1,x);
  FOR n:=x to y DO
    WRITE ('                                                                             ');
    GOTOXY (66,24); WRITE ('            ');
    GOTOXY (1,x);
END;



FUNCTION intercept (gb, hc : extended):extended;
BEGIN
  intercept := 60 * (gb-hc);
  WRITELN; WRITELN;
END;


procedure bildpunktanschrieb;
BEGIN
  WRITE (INT(grtgrad):3:0,' ',(frac(grtgrad)*60):3:1,'');
  GOTOXY (40,12);
  WRITE ('  Deklination: ',INT(decgrad):2:0,' ',
        (frac(decgrad)*60):3:1,'');
  IF decgrad < 0 THEN write (' S')
                 ELSE write (' N');
END;




function RAnachGRT (raa:extended):extended;
BEGIN
  raa:=raa*360/24;
  raa:=ariesgrad-raa;
  IF raa<0 THEN raa:=raa+360;
  RAnachGRT := raa;
END;



PROCEDURE MONDQTH;
VAR TJD, Radius, S : EXTENDED;
    H, M         : INTEGER;
BEGIN
  TJD := (MJD(tag,monat,jahr,stu+min/60+sec/3600)-51544.5)/36525.0;
  MOONEQU (TJD,RA,DE,Radius);
  RA := RA * 24/360;
  grtgrad := RAnachGRT (RA);
  decgrad := DE;
  PAR := ASN (1.0/Radius);
  DMS (PAR,H,M,S);
  HP := 60*H + M + S/60;
END;




PROCEDURE ARIESPFLEGER (t1,m1,j1,h1,m9,s9 : INTEGER);
BEGIN
  T := MJD (t1,m1,j1, h1 + m9/60 + s9/3600);
  ariesgrad := 15 * LMST (T,0);
END;




PROCEDURE ini;
VAR code                                  : INTEGER;
    datum, zeit                           : STRING;
    j,t,m,wtag                            : WORD;
BEGIN
  esc := FALSE;
  WRITE ('           DATUM:             Tag Monat Jahr : ');   eingabe (datum);
  VAL (COPY(datum,1,2),tag,code);
  IF code <> 0 THEN BEGIN
                      datum := '0'+datum;
                      VAL (COPY(datum,1,2),tag,code);
                    END;
  VAL (COPY(datum,4,2),monat,code);
  IF code <> 0 THEN BEGIN
                      datum := COPY(datum,1,3)+'0'+COPY(datum,4,6);
                      VAL (COPY(datum,4,2),monat,code);
                    END;
  VAL (COPY(datum,7,4),jahr,code);
  IF (jahr < 100) THEN jahr := 2000+jahr;

  IF esc = TRUE THEN EXIT;

  {Systemdatumbernahme}
  IF (tag=0) and (monat=0) THEN BEGIN
                                  GETDATE (j,m,t,wtag);
                                  tag :=t;
                                  monat :=m;
                                  jahr := j;
                                END;

  GOTOXY (48,8);  TEXTBACKGROUND (7); TEXTCOLOR (0);
  WRITELN ('                 ');
  GOTOXY (48,8);
  WRITELN ('    ',tag,'.',monat,'.',jahr);
  TEXTCOLOR (7); TEXTBACKGROUND (0);

  WRITE ('           UHRZEIT in UT1:         h min sec : '); eingabe (zeit);

  {Systemzeitbernahme}
  IF zeit = '' THEN
                 BEGIN
                   GETTIME (j,m,t,wtag);
                   stu :=j;
                   min :=m;
                   sec := t;
                 END
                 ELSE


  BEGIN
  VAL (COPY(zeit,1,2),stu,code);
  IF code <> 0 THEN BEGIN
                      zeit := '0'+zeit;
                      VAL (COPY(zeit,1,2),stu,code);
                    END;

  VAL (COPY(zeit,4,2),min,code);
  IF code <> 0 THEN BEGIN
                      zeit := COPY(zeit,1,3)+'0'+COPY(zeit,4,6);
                      VAL (COPY(zeit,4,2),min,code);
                    END;

  VAL (COPY(zeit,7,2),sec,code);
  IF (sec < 10) or (code <>0) THEN
                             BEGIN
                               zeit := COPY(zeit,1,6)+'0'+COPY(zeit,7,1);
                               VAL (COPY(zeit,7,2),sec,code);
                             END;

  END;
  IF esc = TRUE THEN EXIT;

  GOTOXY (48,9); Textbackground (7); TEXTCOLOR (0);
  WRITELN ('                 ');  GOTOXY (48,9);
  WRITELN ('  ',stu,'h ',min,'min ',sec,'s');
  TEXTCOLOR (7); TEXTBACKGROUND (0);

  ARIESPFLEGER (tag, monat, jahr, stu, min, sec);
END;




PROCEDURE winkelini ( VAR wgrad, wmin, wdez : extended);
VAR code, code1, code2   : INTEGER;
    winkelstr            : STRING;
    Minus                : BOOLEAN;

BEGIN
  esc := FALSE;
  eingabe (winkelstr);

  Minus := False;
  IF COPY(winkelstr,0,1)= '-' THEN Minus := True;

  VAL (winkelstr,wgrad,code1);
  IF code1 <> 0 THEN VAL (COPY(winkelstr,1,code1-1),wgrad,code);


  VAL (COPY(winkelstr,code1+1,20),wmin,code2);

  IF Minus = True THEN wmin := 0-wmin;
  if code1 = 0 THEN wmin :=0;
  wdez:=wgrad + (wmin/60);
  IF esc = TRUE THEN EXIT;

END;


PROCEDURE gisort;
VAR grad, min : extended;

BEGIN
  WRITE ('    GEGITE BREITE : ');
  winkelini (grad, min, gisb);
  IF esc = TRUE THEN EXIT;

  TEXTCOLOR (0); TEXTBACKGROUND (7);
  GOTOXY (22,15);  IF grad > 0 THEN write (grad:3:0,' ')
                               ELSE write (grad:4:0,' ');
                   write (min:3:1,' ');
  IF gisb <0 THEN WRITE ('S ')  ELSE write ('N ');
  TEXTCOLOR (7); TEXTBACKGROUND (0);

  GOTOXY (42,15); WRITE ('GEGITE LNGE : ');
  winkelini (grad,min, gisl);
  IF esc = TRUE THEN EXIT;

  TEXTCOLOR (0); TEXTBACKGROUND (7);
  GOTOXY (58,15);  IF grad > 0 THEN write (grad:4:0,' ')
                               ELSE write (grad:5:0,' ');
                   write (min:3:1,' ');
  IF gisl <0 THEN WRITE ('E ')  ELSE write ('W ');
  TEXTCOLOR (7);  TEXTBACKGROUND (0);
END;






PROCEDURE winkelein;
VAR hilfstring   : STRING;
    code         : INTEGER;
    grad, min    : extended;
BEGIN
  aug :=1;    {damit kein sqr(0)-error 207 beim Abbruch mit esc von Mond kommt}

  GOTOXY (21,21);
  WINKELINI (grad, min, hohe);
  IF esc = TRUE THEN EXIT;
  GOTOXY (21,21); TEXTBACKGROUND (7); TEXTCOLOR (0);
  write (grad:3:0,' ');
  write (min:2:1,' ');
  TEXTBACKGROUND (0); TEXTCOLOR (7);

  GOTOXY (40,21);
  WRITE ('AUGENHHE: ');
  eingabe (hilfstring);
  IF esc = TRUE THEN EXIT;
  VAL (hilfstring,aug,code);
  TEXTBACKGROUND (7); TEXTCOLOR (0); GOTOXY (51,21);
  WRITELN (aug:4:1,' m '); TEXTCOLOR (7); TEXTBACKGROUND (0);
END;



PROCEDURE sextantsonnegb;
BEGIN
  GOTOXY (1,21);
  WRITE ('     SEXTANTWINKEL: ');
  winkelein;
  IF esc = TRUE THEN EXIT;
  IF  hohe <> 0          THEN gb:=16.55-60/hohe+0.25*cs(30*monat)-1.8*sqrt(aug)
                         ELSE gb := 0;
  HIGHVIDEO;
  GOTOXY (61,21); WRITELN (' (Gb: ',gb:3:1,')');        lowvideo;
  gb:=hohe+gb/60;
END;



PROCEDURE sextantsterngb;
BEGIN
  IF ch = '5' THEN HP:=0;
  GOTOXY (1,21);
  WRITE ('     SEXTANTWINKEL: ');
  winkelein;
  IF (hohe<>0) AND (aug >= 0) THEN  gb:=0.4-60/hohe-1.8*SQRT(aug)
               ELSE  gb := 0;

  IF ch = '4'THEN gb:= gb+60*hp*cs(hohe);      {Verbesserung fr Parallaxe}
  HIGHvideo;
  GOTOXY (60,21); WRITELN ('(Gb: ',gb:3:1,')');        lowvideo;
  gb:=hohe+gb/60;
END;





PROCEDURE hoheaz;
VAR z : extended;
BEGIN
  hchc:=asn(sn(decgrad)*sn(gisb)+cs(decgrad)*cs(gisb)*
          cs(grtgrad-gisl));

  z:= acs((sn(decgrad)-sn(gisb)*sn(hchc))/(cs(hchc)*cs(gisb)));

  IF sn(grtgrad-gisl) > 0 THEN azimut := 360 - z
                          ELSE azimut := z;

  WRITELN; WRITELN;              highvideo;
  WRITE ('                Azimuth: ',azimut:4:1,'           Hc: ',INT(hchc):3:0);
  WRITELN (' ',((hchc-int(hchc))*60):3:1,'');             lowvideo;
END;







PROCEDURE PLANETI (DAY, MONTH, YEAR :INTEGER; stu, min, sec:extended;
                   planet :STRING);

VAR   ent                                  : extended;
      X,Y,Z, XP,YP,ZP, XS,YS,ZS            : extended;
      L,B,R, LS,BS,RS, DELTA,DELTA0        : extended;
      iplan                                : INTEGER;

BEGIN (* PLANPOS *)
        L:=0;  B:=0;  R:=0;
        hour := stu+(min/60)+(sec/3600);
        MODJD := MJD (DAY,MONTH,YEAR,HOUR);
        T:=(MODJD-51544.5)/36525.0;

        SUN200(T,LS,BS,RS);

        IF planet = 'Sonne'   THEN iplan := 0;
        IF planet = 'Venus'   THEN iplan := 2;
        IF planet = 'Mars'    THEN iplan := 4;
        IF planet = 'Jupiter' THEN iplan := 5;
        IF planet = 'Saturn'  THEN iplan := 6;


         IF IPLAN >2 THEN  BEGIN L:=LS+180.0; B:=-BS; R:=RS; END;

            CASE IPLAN OF
              2: VEN200(T,L,B,R);
              4: MAR200(T,L,B,R); 5: JUP200(T,L,B,R); 6: SAT200(T,L,B,R);
             END;



            (* geocentric ecliptic coordinates (light-time corrected)  *)

            GEOCEN (T, L,B,R, LS,BS,RS, IPLAN,2,
                    XP,YP,ZP, XS,YS,ZS, X,Y,Z,DELTA0);

            (* precession, equatorial coordinates, nutation            *)


                ECLEQU(T,X,Y,Z); NUTEQU(T,X,Y,Z);

            (* spherical coordinates *)

            POLAR (XP,YP,ZP,R,B,L);
            POLAR (X,Y,Z,DELTA,DEC,RA); RA:=RA/15.0;

            (* output *)


            ENT := DELTA0 * 149.59787E6;
            HP := ASN (6378.14/ENT);

            grtgrad := RAnachGRT (RA);
            decgrad := DEC;

END;



PROCEDURE SONNE;
VAR iii:extended;

BEGIN
  HOME (5,24);                          TEXTCOLOR (12);
  WRITELN ('                           Unterrand  S O N N E ');
  WRITELN ('                        --------------------------');   TEXTCOLOR (7);
  WRITELN; lowvideo;
  ini;    IF esc = TRUE THEN EXIT;
  GOTOXY (2,12); Write ('Bitte warten...');

  planeti (tag,monat,jahr, stu,min,sec, 'Sonne');

  WRITELN;  WRITELN;                    highvideo;
  GOTOXY (1,12); WRITE (' Sonnenbildpunkt:     Grt: ');

  bildpunktanschrieb;

  WRITELN; WRITELN;   WRITELN;                            lowvideo;
  gisort;
  IF esc = TRUE THEN EXIT;
  hoheaz;
  WRITELN;  WRITELN;
  sextantsonnegb;
  IF esc = TRUE THEN EXIT;
  iii:= INTERCEPT (gb,hchc);
  GOTOXY(1,23);                        highvideo;
  WRITE ('                     Der Unterschied betrgt: ',iii:4:1,' sm');
  WRITELN;   WRITELN;                         TEXTCOLOR (12);
  WRITE ('  -->  Nun die astronomische Standlinie in die Seekarte einzeichnen!  <--');
  repeat until keypressed; ch:= readkey;         lowvideo;       TEXTCOLOR(7);

  INC (standlinienzaehler);
  Linienspeicher[standlinienzaehler].tag := tag;
  Linienspeicher[standlinienzaehler].monat := monat;
  Linienspeicher[standlinienzaehler].jahr := jahr;
  Linienspeicher[standlinienzaehler].h := stu;
  Linienspeicher[standlinienzaehler].m := min;
  Linienspeicher[standlinienzaehler].s := sec;
  Linienspeicher[standlinienzaehler].gestirn := 'Sonne';
  Linienspeicher[standlinienzaehler].laenge :=  gisl;
  Linienspeicher[standlinienzaehler].breite :=  gisb;
  Linienspeicher[standlinienzaehler].azimut :=  azimut;
  Linienspeicher[standlinienzaehler].distanz := iii;
END;



PROCEDURE arrayloeschen;
VAR j : INTEGER;

BEGIN
  standlinienzaehler := 0;
  FOR J:=1 to 10 DO
  BEGIN
  Linienspeicher[j].tag := 0;
  Linienspeicher[j].monat := 0;
  Linienspeicher[j].jahr := 0;
  Linienspeicher[j].h := 0;
  Linienspeicher[j].m := 0;
  Linienspeicher[j].s := 0;
  Linienspeicher[j].gestirn := '';
  Linienspeicher[j].laenge :=  0;
  Linienspeicher[j].breite :=  0;
  Linienspeicher[j].azimut :=  0;
  Linienspeicher[j].distanz := 0;
  END;
END;



PROCEDURE DATEIENDA;

VAR F          : SEARCHREC;
    NJ, INFO   : BOOLEAN;

BEGIN
  NJ := FALSE; INFO := FALSE;
  FINDFIRST ('*.*',archive,F);
  IF F.Name = 'NJ.EXE' THEN NJ := TRUE;
  IF F.Name = 'INFO.TXT' THEN INFO := TRUE;
  WHILE (DOSERROR = 0) AND NOT((NJ=TRUE)AND(INFO=TRUE)) DO
     BEGIN
       FINDNEXT (F);
       IF F.Name = 'NJ.EXE' THEN NJ := TRUE;
       IF F.Name = 'INFO.TXT' THEN INFO := TRUE;
     END;

  IF (NJ=FALSE) OR (INFO=FALSE) THEN
  BEGIN
   TEXTCOLOR (LIGHTRED);
   WRITELN;
   WRITELN ('Dieses Programm ist unvollstndig kopiert worden!  Es fehlt:', chr(7));
   WRITELN;
   IF NJ = FALSE THEN
   WRITELN ('  NJ.EXE     zum Drucken der Tagesseiten des Nautischen Jahrbuchs');
   IF INFO = FALSE THEN
   WRITE ('  INFO.TXT   ein Textfile mit Hinweisen zur Programmanwendung   ');
   REPEAT UNTIL KEYPRESSED; CH := READKEY;
   TEXTCOLOR (7);
  END;
END;



PROCEDURE Sternelesen;
VAR ii, code : INTEGER;
    w,d      : STRING [20];

BEGIN
  arrayloeschen;

  name[ 1] := 'Sirrah              35754.2             2905.4';
  name[ 2] := 'Algenib im Pegasus  35644.5             1510.2';      {?}
  name[ 3] := ' Phoenicis         35325.8             -4218.4';
  name[ 4] := 'Schedir             34956.4             5630.7';      {?}
  name[ 5] := 'Deneb Kaitos        34906.2             -1759.2';
  name[ 6] := 'Gamma Cassiopeiae   34553.9             6041.9';      {?}
  name[ 7] := 'Mirach              34234.0             3537.2';
  name[ 8] := 'Archernar           33534.3             -5714.2';
  name[ 9] := 'Nordstern           32403.6             8915.2';      {?}
  name[10] := 'Alamak              32905.4             4218.9';      {?}
  name[11] := 'Hamel               32812.4             2327.7';
  name[12] := 'Menkar              31425.8             405.4';
  name[13] := 'Algol               31257.5             4057.3';
  name[14] := 'Algenib im Perseus  30855.2             4951.7';
  name[15] := 'Alcyone             30307.8             2406.3';
  name[16] := 'Aldebaran           29101.2             1630.5';
  name[17] := 'Rigel               28122.0             -812.1';
  name[18] := 'Capella             28049.7             4559.9';
  name[19] := 'Bellatrix           27843.0             621.0';
  name[20] := ' Tauri             27829.4             2837.0';      {?}
  name[21] := ' Orionis           27559.7             -113.4';      {?}
  name[22] := 'Chi Orionis         27451.5             -155.7';      {?}
  name[23] := 'Xi Orionis          27306.5             -939.6';      {?}
  name[24] := 'Beteigeuze          27112.4             724.4';
  name[25] := ' Aurigae           27007.1             4456.8';
  name[26] := ' Canis majoris     26421.9             -1756.8';     {?}
  name[27] := 'Canopus             26400.7             -5241.7';
  name[28] := 'Gamma Geminorum     26034.3             1624.0';
  name[29] := 'Sirius              25842.8             -1643.0';
  name[30] := ' Canis majoris     25520.2             -2858.3';
  name[31] := ' Canis majoris     25256.6             -2622.8';     {?}
  name[32] := 'Castor              24621.0             3153.3';
  name[33] := 'Procyon             24510.5             513.5';
  name[34] := 'Pollux              24340.3             2801.6';
  name[35] := ' Carinae           23422.3             -5930.6';
  name[36] := 'Lambda Velorum      22302.4             -4324.4';     {?}
  name[37] := ' Carinae           22142.0             -6943.0';
  name[38] := 'Alphard             21806.2             -839.5';
  name[39] := 'Regulus             20754.5             1158.0';
  name[40] := ' Carinae           19919.1             -6421.8';     {?}
  name[41] := 'Dubhe               19404.1             6145.0';
  name[42] := 'Denebola            18244.1             1434.3';
  name[43] := ' Crucis            17321.0             -6305.9';
  name[44] := 'Gamma Crucis        17212.5             -5706.8';
  name[45] := ' Crucis            16804.2             -5941.3';
  name[46] := 'Alioth              16639.9             5602.7';      {?}
  name[47] := 'Vindemiatrix        16439.1             1102.6';      {?}
  name[48] := 'Mizar               15910.6             5500.4';      {?}
  name[49] := 'Spica               15842.1             -1109.7';
  name[50] := 'Benetnasch          15306.9             4918.8';
  name[51] := ' Centauri          14902.7             -6022.4';
  name[52] := ' Centauri          14833.8             -3617.6';     {?}
  name[53] := 'Arcturus            14605.1             1911.0';
  name[54] := ' Centauri          14005.8             -6050.0';
  name[55] := 'Mirak               13855.5             2708.4';      {?}
  name[56] := 'Zubenelgenubi       13716.9             -1602.5';
  name[57] := 'Kochab              13719.5             7409.3';
  name[58] := 'Zubeneschemali      13057.7             -919.6';      {?}
  name[59] := 'Gemma               12629.7             2646.0';      {?}
  name[60] := 'Unuk                12356.0             625.5';
  name[61] := 'Antares             11238.9             -2625.9';
  name[62] := ' Trianguli A.      10750.1             -6901.6';
  name[63] := ' Scorpii           10743.0             -3416.0';     {?}
  name[64] := 'Lambda Scorpii       9635.9             -3706.2';
  name[65] := 'Ras Alhague          9616.0             1233.6';
  name[66] := ' Scorpii            9540.3             -4259.6';
  name[67] := 'Eltanin              9051.0             5129.3';
  name[68] := ' Sagittarii         8357.4             -3423.1';
  name[69] := 'Wega                 8045.9             3847.0';
  name[70] := ' Sagittarii         7625.7             -2619.1';     {?}
  name[71] := 'Altair               6218.3             852.1';
  name[72] := ' Pavonis            5335.3             -5644.1';
  name[73] := 'Deneb                4938.6             4516.8';
  name[74] := 'Alderamin            4027.1             6231.1';      {?}
  name[75] := 'Enif                 3357.2             952.5';
  name[76] := ' Gruis              2756.6             -4657.7';
  name[77] := ' Gruis              1920.0             -4653.1';
  name[78] := 'Fomalhaut            1535.3             -2937.3';
  name[79] := 'Scheat               1414.9             2759.8';
  name[80] := 'Markab               1400.4             1507.2';

  II:=0;
  WHILE ii<80 DO BEGIN
     II:=II+1;
                        w := COPY (name[ii],21,7);
                        VAL(w, winkel[ii],code);
                        IF code <> 0 THEN BEGIN
                                            w:=COPY(w,1,code-1);
                                            VAL(w,winkel[ii],code);
                                          END;
                        d := COPY (name[ii],41,7);
                        VAL(d, decli[ii],code);
                        IF code <> 0 THEN BEGIN
                                            d:=COPY(d,1,code-1);
                                            VAL(d,decli[ii],code);
                                          END;

                      END;
END;




PROCEDURE Sternpositionsberichtigung (sternwinkelalt, decgradalt:EXTENDED;
                                      tag, monat, jahr,
                                      stunde, minute, sekunde:INTEGER;
                                      VAR sternwinkelneu, decgradneu:EXTENDED);
VAR JD, Zeit, GW, G, LM, L, EP,
    HI1, HI2, HI3, HI4, HI5, TA,
    BETA, BETA1, BETA2, M, N,
    DEL, DEL1, DEL2, TJUL            : EXTENDED;

BEGIN
  {Berechnung verschiedener astronomischer Grundgren: }
  write ('');
  Zeit := Stunde + Minute/60 + Sekunde/3600;
  JD := MJD(tag, monat, jahr, Zeit);               {MJD = Julianisches Datum,
                                                    aus Montenbruck/Pfleger}
  TA := JD-51544.5;

  G := 357.528+0.9856003*TA;                      {mittlere Sonnenanomalie}
  LM := 280.46+0.9856474*TA;                      {mittlere Sonnenlnge}
  L := LM+1.915*SN(G)+0.2*SN(2*G);                  {Sonnenlnge}
  L := L-360*INT(L/360);
  EP := 23.439-0.0000004*TA;                      {Schiefe der Ekliptik}

  TJUL := TA/36525;
  M := 1.2812323*TJUL+0.0003879*TJUL*TJUL;
  N := 0.5567530000000001*TJUL-0.0001185*TJUL*TJUL;

  BETA := sternwinkelalt;
  DEL  := decgradalt;

  {Korrektur Przession:   }
  BETA1 := BETA-M+N*SN(BETA)*TN(DEL);
  DEL1  := DEL+N*CS(BETA);

  {Korrektur Aberation:    }
  HI1 := CS(BETA1)*CS(EP)*CS(L);
  HI2 := SN(BETA1)*SN(L);
  HI3 := CS(DEL1)*SN(EP)*CS(L);
  HI4 := CS(BETA1)*SN(DEL1)*SIN(L);
  HI5 := SN(BETA1)*SN(DEL1)*CS(EP)*CS(L);
  BETA2 := BETA1+0.005694*(HI1-HI2)/CS(DEL1);
  DEL2 := DEL1-0.005694*(HI3+HI4+HI5);

  sternwinkelneu := BETA2;
  decgradneu := DEL2;
END;




PROCEDURE Stern;
VAR iii, decgradneu, sternwinkelneu   :extended;
    Stern, code  : INTEGER;
    hilfstring   : STRING;

BEGIN
  HOME (5,24);                          TEXTCOLOR (12);
  WRITELN ('                                S T E R N E');
  WRITELN ('                              ---------------');   TEXTCOLOR (7);
  WRITELN; lowvideo;
  ini;

  IF esc = TRUE THEN EXIT;
  WRITE (' NAVIGATIONS-STERN-NUMMER: ');


  REPEAT
    GOTOXY(28,10); WRITELN ('                                             ');
    GOTOXY(28,10);
    eingabe (hilfstring);
    IF ESC = TRUE THEN EXIT;
    VAL (hilfstring, stern,code);
  UNTIL (stern>0)AND(stern<81);

  IF ESC = TRUE THEN EXIT;
  IF code <> 0 THEN name[stern] := ' ';
                    highvideo;
  sternwinkel:=INT(winkel[stern]/100) +
               (winkel[stern]-INT(winkel[stern]/100)*100)/60;
  GOTOXY (31,10);  WRITELN (COPY(name[stern],1,20));
  GOTOXY (59,10);  WRITE ('Aries: ');
  WRITELN (INT(ariesgrad):3:0,' ',(frac(ariesgrad)*60):3:1,'');
  decgrad :=  INT(decli[stern]/100)
              +(decli[stern]-INT(decli[stern]/100)*100)/60;

  STERNPOSITIONSBERICHTIGUNG (sternwinkel, decgrad,
                              tag, monat, jahr,
                              stu, min, sec,
                              sternwinkelneu, decgradneu);

  decgrad := decgradneu;   sternwinkel := sternwinkelneu;


  grtgrad:= sternwinkel+ariesgrad;
  IF grtgrad > 360 Then grtgrad:= grtgrad - 360;
  WRITELN;

  WRITE (' Sternbildpunkt:    Grt: ');

  bildpunktanschrieb;

  WRITELN; WRITELN; WRITELN;                               lowvideo;
  gisort;
  IF ESC = TRUE THEN EXIT;
  hoheaz;
  WRITELN;  WRITELN;
  sextantsterngb;
  IF ESC = TRUE THEN EXIT;
  iii:= INTERCEPT (gb,hchc);
  GOTOXY(1,23);                        highvideo;
  WRITE ('                     Der Unterschied betrgt: ',iii:4:1,' sm');
  WRITELN;   WRITELN;                         TEXTCOLOR (12);
  WRITE ('  -->  Nun die astronomische Standlinie in die Seekarte einzeichnen!  <--');
  repeat until keypressed; ch:= readkey;         lowvideo;       TEXTCOLOR(7);


  INC (standlinienzaehler);
  Linienspeicher[standlinienzaehler].tag := tag;
  Linienspeicher[standlinienzaehler].monat := monat;
  Linienspeicher[standlinienzaehler].jahr := jahr;
  Linienspeicher[standlinienzaehler].h := stu;
  Linienspeicher[standlinienzaehler].m := min;
  Linienspeicher[standlinienzaehler].s := sec;
  Linienspeicher[standlinienzaehler].gestirn := name[stern];
  Linienspeicher[standlinienzaehler].laenge :=  gisl;
  Linienspeicher[standlinienzaehler].breite :=  gisb;
  Linienspeicher[standlinienzaehler].azimut :=  azimut;
  Linienspeicher[standlinienzaehler].distanz := iii;
END;


PROCEDURE sextantmondgb (ober : INTEGER);
BEGIN
  GOTOXY (1,21);
  WRITE ('     SEXTANTWINKEL: ');
  winkelein;
  IF hohe > 50 THEN BEGIN
                      gb:=0.63-60/(hohe-1)+HP*cs(hohe)-1.8*sqrt(aug);
                      IF ober = 1 THEN gb:=gb-HP*0.272
                                  ELSE gb:=gb+HP*0.272
                    END
               ELSE BEGIN
                      gb:=0.49-60/(hohe-1)+HP*cs(hohe) -1.8*SQRT(aug);
                      IF ober = 1 THEN gb:=gb-HP*0.272
                                  ELSE gb:=gb+HP*0.272
                    END;
                HIGHvideo;
  GOTOXY (60,21); WRITELN ('(Gb: ',gb:3:1,')');        lowvideo;
  gb:=hohe+gb/60;
END;


PROCEDURE mond (ober:INTEGER);
VAR iii  : extended;

BEGIN
  HOME (5,24);                          TEXTCOLOR (12);
  IF ober = 1 THEN BEGIN
  WRITELN ('                             Oberrand  M O N D');
  WRITELN ('                         -------------------------');
                   END;
  IF ober = 0 THEN BEGIN
  WRITELN ('                            Unterrand  M O N D');
  WRITELN ('                        --------------------------');
                   END;


                      TEXTCOLOR (7);
  WRITELN; lowvideo;
  ini;
  IF esc = TRUE THEN EXIT;
  highvideo;


  WRITELN;
  WRITELN (' ');
  GOTOXY (2,12); Write ('Bitte warten...');
  mondqth;
  GOTOXY (5,11);
  WRITELN ('                                                  ');
  WRITE (' Mondbildpunkt  Grt: ');


  bildpunktanschrieb;

  WRITELN ('   HP: ',HP:2:1);
  WRITELN; WRITELN;                               lowvideo;
  gisort;
  IF esc = TRUE THEN EXIT;
  hoheaz;
  WRITELN;  WRITELN;
  sextantmondgb (ober);
  IF esc = TRUE THEN EXIT;
  iii:= INTERCEPT (gb,hchc);
  GOTOXY(1,23);                        highvideo;
  WRITE ('                     Der Unterschied betrgt: ',iii:4:1,' sm');
  WRITELN;   WRITELN;                         TEXTCOLOR (12);
  WRITE ('  -->  Nun die astronomische Standlinie in die Seekarte einzeichnen!  <--');
  repeat until keypressed; ch:= readkey;         lowvideo;       TEXTCOLOR(7);


  INC (standlinienzaehler);
  Linienspeicher[standlinienzaehler].tag := tag;
  Linienspeicher[standlinienzaehler].monat := monat;
  Linienspeicher[standlinienzaehler].jahr := jahr;
  Linienspeicher[standlinienzaehler].h := stu;
  Linienspeicher[standlinienzaehler].m := min;
  Linienspeicher[standlinienzaehler].s := sec;
  Linienspeicher[standlinienzaehler].gestirn := 'Mond';
  Linienspeicher[standlinienzaehler].laenge :=  gisl;
  Linienspeicher[standlinienzaehler].breite :=  gisb;
  Linienspeicher[standlinienzaehler].azimut :=  azimut;
  Linienspeicher[standlinienzaehler].distanz := iii;
END;



PROCEDURE unterini;

BEGIN
  GOTOXY (1,10);
  WRITE ('           Name des Navigationsplaneten      : '); eingabe (planet);

  IF esc = TRUE THEN EXIT;

  eini := False;
  IF (planet='Venus')OR(planet='venus') THEN BEGIN
                                               planet := 'Venus';
                                               eini := true;
                                             END;
  IF (planet='Mars')OR(planet='mars') THEN BEGIN
                                             planet := 'Mars';
                                             eini := true;
                                           END;
  IF (planet='Jupiter')or(planet='jupiter') THEN BEGIN
                                                   planet:='Jupiter';
                                                   eini := true;
                                                 END;
  IF (planet='Saturn')OR(planet='saturn') THEN BEGIN
                                                 planet := 'Saturn';
                                                 eini := true;
                                               END;
  END;



PROCEDURE wandelstern;
VAR iii  : extended;


BEGIN
  HOME (5,24);                          TEXTCOLOR (12);
  WRITELN ('                              P L A N E T E N');
  WRITELN ('                            -------------------');   TEXTCOLOR (7);
  WRITELN; lowvideo;
  ini;
  IF esc = TRUE THEN EXIT;
  unterini;

  WHILE (eini = false) AND (esc = false) DO unterini;
  If esc = true THEN EXIT;
  GOTOXY (2,12); Write ('Bitte warten...');

  planeti (tag, monat, jahr, stu, min, sec, planet);


  WRITELN;               highvideo;
  GOTOXY(1,12);
  WRITE (planet,'bildpunkt:   Grt: ');

  bildpunktanschrieb;

  GOTOXY (70,12); WRITE ('HP: ',(60*hp):3:1);
  WRITELN; WRITELN; WRITELN;                               lowvideo;
  gisort;
  IF esc = TRUE THEN EXIT;
  hoheaz;
  WRITELN;  WRITELN;
  sextantsterngb;
  IF esc = TRUE THEN EXIT;
  iii:= INTERCEPT (gb,hchc);
  GOTOXY(1,23);                        highvideo;
  WRITE ('                     Der Unterschied betrgt: ',iii:4:1,' sm');
  WRITELN;   WRITELN;                         TEXTCOLOR (12);
  WRITE ('  -->  Nun die astronomische Standlinie in die Seekarte einzeichnen!  <--');
  repeat until keypressed; ch:= readkey;         lowvideo;       TEXTCOLOR(7);

  INC (standlinienzaehler);
  Linienspeicher[standlinienzaehler].tag := tag;
  Linienspeicher[standlinienzaehler].monat := monat;
  Linienspeicher[standlinienzaehler].jahr := jahr;
  Linienspeicher[standlinienzaehler].h := stu;
  Linienspeicher[standlinienzaehler].m := min;
  Linienspeicher[standlinienzaehler].s := sec;
  Linienspeicher[standlinienzaehler].gestirn := planet;
  Linienspeicher[standlinienzaehler].laenge :=  gisl;
  Linienspeicher[standlinienzaehler].breite :=  gisb;
  Linienspeicher[standlinienzaehler].azimut :=  azimut;
  Linienspeicher[standlinienzaehler].distanz := iii;
END;




PROCEDURE kartesischerSchnitt (rx1, ry1, d1, alpha1,
                               rx2, ry2, d2, alpha2   : EXTENDED;
                               VAR schnitty, schnittx : EXTENDED);
VAR  m1,m2,b,c,px1,py1,px2,py2 : EXTENDED;

BEGIN
  py1 := ry1 + d1 * cs(alpha1);          {Punkt auf Standlinie1 und Azimut1}
  px1 := rx1 + d1 * sn(alpha1);

  px2 := rx2 + d2 * sn (alpha2);         {Punkt auf Standlinie2 und Azimut2}
  py2 := ry2 + d2 * cs (alpha2);

  m1 := 1/tn (alpha1 + 90);              {Steigung Standlinie1}
  m2 := 1/tn (alpha2 + 90);              {Steigung Standlinie2}
  b  := py1 -px1 * 1/tn(alpha1+90);      {Y-Achsenabschnitt Standlinie1}
  c  := py2 -px2 * 1/tn(alpha2+90);      {Y-Achsenabschnitt Standlinie2}
  schnittx := (b-c)/(m2-m1);             {Scnittpunktkoordinaten kartesisch}
  schnitty := (m1 * (b-c)/(m2-m1)) + b;
END;




PROCEDURE Schnitt (linie1,linie2 : STANDLINIE; rechenbreite : EXTENDED;
                   VAR posbreite, poslaenge : EXTENDED);

VAR trafolaenge1, trafolaenge2,x ,y, distanz1,distanz2    : EXTENDED;

BEGIN
  trafolaenge1 := -linie1.laenge   * cs(rechenbreite);  {Koordinatentrafo}
  trafolaenge2 := -linie2.laenge   * cs(rechenbreite);

  distanz1     := linie1.distanz /60;  {Umrechnung sm in Grad}
  distanz2     := linie2.distanz /60;

  kartesischerSchnitt (trafolaenge1,linie1.breite,distanz1,linie1.azimut,
                       trafolaenge2,linie2.breite,distanz2,linie2.azimut,
                       y,x);

  posbreite := y;

  IF rechenbreite > 0 THEN poslaenge := -x / cs(rechenbreite)
                      ELSE poslaenge :=  x / cs(rechenbreite);
                      {Koordinatenrcktrafo}
END;


PROCEDURE standlinienanschrieb;
Var j, zeile,m,g  : INTEGER;
    s             : EXTENDED;

BEGIN
  WRITELN ('Nr.   Datum       Zeit     Gestirn      Breite    Lnge    Azimuth   Distanz');
  WRITELN;
  ZEILE :=0;
  FOR j :=1 to 10 DO
  BEGIN
    IF Linienspeicher[j].tag >0 THEN
    BEGIN
      WRITE (j:2,') ');
      WRITE (Linienspeicher[j].tag:2,'.');
      WRITE (linienspeicher[j].monat:2,'.');
      WRITE (Linienspeicher[j].jahr:4,'  ');
      WRITE (Linienspeicher[j].h:2,'-');
      WRITE (Linienspeicher[j].m:2,'-');
      WRITE (Linienspeicher[j].s:2,'   ');
      WRITE (linienspeicher[j].gestirn);
      GOTOXY (38,zeile+10);   INC (zeile);
      DMS (linienspeicher[j].breite,g,m,s);
      WRITE (g:5,'',(m+s/60):2:0,'');
      DMS (linienspeicher[j].laenge,g,m,s);
      WRITE (g:5,'',(m+s/60):2:0,'' );
      write (linienspeicher[j].azimut:7:1,'' );
      WRITE (linienspeicher[j].distanz:9:1,'sm');    WRITELN;
    END;
  END;
  WRITELN;
END;



PROCEDURE POSITION;
VAR nummer1, nummer2,g,m                              : INTEGER;
    rechenbreite, s, minuten, posbreite, poslaenge,
    azimut1, azimut2                                  : EXTENDED;

BEGIN
  HOME (5,24);                          TEXTCOLOR (12);
  WRITELN ('                              P O S I T I O N');
  WRITELN ('                            -------------------');   TEXTCOLOR (7);
  WRITELN; lowvideo;

  standlinienanschrieb;

  nummer1 :=1;  nummer2 := 2;
  IF standlinienzaehler > 2 THEN
  BEGIN
    WRITE ('    Welche 2 Standlinien wollen Sie schneiden ?    [Zahl Zahl]   :  ');
    READLN (nummer1, nummer2);
  END;

  azimut1 := linienspeicher[nummer1].azimut;
  azimut2 := linienspeicher[nummer2].azimut;
  IF (azimut1 >= 340) AND (azimut2 <=20) THEN azimut2 := azimut2+360;
  IF (azimut2 >= 340) AND (azimut1 <=20) THEN azimut1 := azimut1+360;

  IF ABS(azimut1 - azimut2) < 20
  THEN BEGIN
         TEXTCOLOR (15);
         WRITELN;
         WRITELN ('     Standlinien schneiden sich schleifend !! (Schnittwinkel < 20)');
         WRITE   ('     Positionsberechnung macht daher keinen Sinn...   ');
         positionberechnet := FALSE;
         REPEAT UNTIL KEYPRESSED; CH := READKEY; EXIT;
       END
       ELSE

  rechenbreite := ((linienspeicher[nummer1].breite +
                    linienspeicher[nummer2].breite ) / 2);
  SCHNITT (Linienspeicher[nummer1], linienspeicher[nummer2], rechenbreite,
           posbreite, poslaenge);

  rechenbreite := (rechenbreite + posbreite ) / 2;

  SCHNITT (Linienspeicher[nummer1], linienspeicher[nummer2], rechenbreite,
           posbreite, poslaenge);


  GOTOXY (1,23);
  TEXTCOLOR (15);
  DMS (posbreite,g,m,s);
  IF g > 0 THEN minuten := m+s/60 ELSE minuten := -1*(m+s/60);
  WRITE ('  Ihre Schiffsposition nach Breite und Lnge :  ',ABS(g):3,' ',
          ABS(minuten):3:1,'');
  IF g > 0 THEN WRITE ('N') ELSE WRITE ('S');

   DMS (poslaenge,g,m,s);
  IF g > 0 THEN minuten := m+s/60 ELSE minuten := -1*(m+s/60);
  WRITE ('  ',ABS(g):3,' ',ABS(minuten):3:1,'');
  IF g > 0 THEN WRITE  ('W ') ELSE WRITE ('E ');

  fixlaenge := poslaenge;
  fixbreite := posbreite;

  positionberechnet := TRUE;
  REPEAT UNTIL KEYPRESSED; CH := READKEY;

END;


PROCEDURE versegeln;
VAR nummer, code                                  : INTEGER;
    kurs, sm, rechenbreitealt, rechenlaengealt    : EXTENDED;
    nummerstring, kursstring, smstring            : STRING;

BEGIN
  HOME (5,24);                          TEXTCOLOR (12);
  WRITELN ('                 S T A N D L I N I E N  V E R S E G E L N');
  WRITELN ('              ----------------------------------------------');
  TEXTCOLOR (7);
  WRITELN; lowvideo;
  standlinienanschrieb;
  nummer := 1;
  IF standlinienzaehler > 1 THEN
  BEGIN
    WRITE ('  Welche Standlinie wollen Sie versegeln ? : ');
    escreadln (nummerstring);
    if nummerstring = chr(27) THEN exit;
    VAL (nummerstring,nummer, code);
    IF nummer > standlinienzaehler THEN BEGIN
                                          WRITELN; WRITELN; TEXTCOLOR (11);
                                          WRITELN (chr(7));
                                          GOTOXY (7,19);
    WRITELN ('FEHLER :  Diese Standlinie gibt es nicht, Sie Landratte !!! ');
                                          REPEAT UNTIL KEYPRESSED;
                                          ch := READKEY; versegeln;
                                          exit;
                                        END;
  END;
  WRITE ('          gesteuerter, rechtweisender Kurs : ');
  escREADLN (kursstring);
  if kursstring = chr(27) THEN exit;
  VAL (kursstring,kurs,code);
  WRITE ('                   zurckgelegte Seemeilen : ');
  escREADLN (smstring);
  if smstring = chr(27) THEN EXIT;
  VAL (smstring,sm,code);

  rechenbreitealt := linienspeicher[nummer].breite;
  rechenlaengealt := linienspeicher[nummer].laenge;

  linienspeicher[nummer].breite := rechenbreitealt + (sm/60*cs(360-kurs));
  linienspeicher[nummer].laenge := rechenlaengealt + (sm/60*sn(360-kurs)
                                                      /cs(rechenbreitealt));

  WRITELN;
  GOTOXY (1,8);
  standlinienanschrieb;
  GOTOXY (1,24);  TEXTCOLOR (4);  HIGHVIDEO;
  WRITE ('                    -->  Standlinie versegelt !  <--  ');
  REPEAT UNTIL KEYPRESSED; CH := READKEY; LOWVIDEO;
END;



PROCEDURE Zielkurs;
VAR g,m                                                  : INTEGER;
    s, minuten, grad, min, zielbreite, ziellaenge,
    zieldistanz, zielentfernung, zielku                  : extended;

BEGIN
  HOME (5,24);                          TEXTCOLOR (12);
  WRITELN ('          G R O S S K R E I S K U R S   z u m   Z I E L H A F E N');
  WRITELN ('        -----------------------------------------------------------');
  TEXTCOLOR (7);
  WRITELN; WRITELN; WRITELN; lowvideo;

  IF positionberechnet = TRUE  THEN
  BEGIN
    DMS (fixbreite,g,m,s);
    IF g > 0 THEN minuten := m+s/60 ELSE minuten := -1*(m+s/60);
    WRITE ('  Ihre Schiffsposition nach Breite und Lnge :  ',ABS(g):3,' ',
            ABS(minuten):3:1,'');
    IF g > 0 THEN WRITE ('N') ELSE WRITE ('S');

     DMS (fixlaenge,g,m,s);
    IF g > 0 THEN minuten := m+s/60 ELSE minuten := -1*(m+s/60);
    WRITE ('  ',ABS(g):3,' ',ABS(minuten):3:1,'');
    IF g > 0 THEN WRITE  ('W ') ELSE WRITE ('E ');
  END   ELSE
  BEGIN
  {Eingabe des Startortes}
  GOTOXY (1,8);
   WRITE ('     Von wo segeln Sie los ? ');


  WRITE ('     BREITE : ');
  winkelini (grad, min, fixbreite);
  IF esc = TRUE THEN EXIT;

  TEXTCOLOR (0); TEXTBACKGROUND (7);
  GOTOXY (44, 8);  write (grad:5:0,'');
                   write (min:6:1,' ');
  IF  fixbreite <0 THEN WRITE ('S ')  ELSE write ('N ');
  TEXTCOLOR (7); TEXTBACKGROUND (0);

  GOTOXY (35, 9); WRITE ('LNGE  : ');
  winkelini (grad,min, fixlaenge);
  IF esc = TRUE THEN EXIT;

  TEXTCOLOR (0); TEXTBACKGROUND (7);
  GOTOXY (44, 9);   write (grad:5:0,'');
                   write (min:6:1,' ');
  IF fixlaenge <0 THEN WRITE ('E ')  ELSE write ('W ');
  TEXTCOLOR (7);  TEXTBACKGROUND (0);
 END;




  GOTOXY (1,14);
  WRITE ('   Wohin wollen Sie segeln ? ');


  WRITE ('     BREITE : ');
  winkelini (grad, min, zielbreite);
  IF esc = TRUE THEN EXIT;

  TEXTCOLOR (0); TEXTBACKGROUND (7);
  GOTOXY (44,14);  write (grad:5:0,'');
                   write (min:6:1,' ');
  IF zielbreite <0 THEN WRITE ('S ')  ELSE write ('N ');
  TEXTCOLOR (7); TEXTBACKGROUND (0);

  GOTOXY (35,15); WRITE ('LNGE  : ');
  winkelini (grad,min, ziellaenge);
  IF esc = TRUE THEN EXIT;

  TEXTCOLOR (0); TEXTBACKGROUND (7);
  GOTOXY (44,15);  write (grad:5:0,'') ;
                   write (min:6:1,' ');
  IF ziellaenge <0 THEN WRITE ('E ')  ELSE write ('W ');
  TEXTCOLOR (7);  TEXTBACKGROUND (0);

  IF (fixbreite-zielbreite = 0)AND(fixlaenge-ziellaenge = 0) THEN
     BEGIN
       zielku :=360;
       zieldistanz := 0;
    END
     ELSE
    BEGIN
      zieldistanz := 60 * ( acs (sn(fixbreite)*sn(zielbreite) +
                 cs(fixbreite)*cs(zielbreite)*cs(ziellaenge-fixlaenge)));

      zielku := acs( (sn(zielbreite) - sn(fixbreite) * cs(zieldistanz/60)) /
              (cs(fixbreite) * sn(zieldistanz/60)) );
      writeln;
    END;

  {Ziel und Fix auf West bzw. Osthalbkugel}
  IF ((ziellaenge<=0) AND (fixlaenge<=0)) OR
     ((ziellaenge>0) AND (fixlaenge>0)) THEN
     BEGIN
       IF ziellaenge-fixlaenge > 0 THEN Zielku := 360-zielku;
     END;

  {Ziel auf OST, Fix auf WESThalbkugel}
  IF ((ziellaenge<=0) AND (fixlaenge>=0)) THEN Zielku := zielku;

  {Ziel auf WEST, Fix auf OSThalbkugel}
  IF ((ziellaenge>=0) AND (fixlaenge<=0)) THEN Zielku := 360-zielku;


  WRITELN; WRITELN;  WRITELN; WRITELN;   HIGHVIDEO;
  WRITELN ('         rechtweisender Kurs zum Ziel :  ',zielku:5:0,'');
  WRITELN ('                           Entfernung :  ',zieldistanz:5:0,' sm');
  WRITELN;
  TEXTCOLOR (4); HIGHVIDEO;
  WRITE ('        -->  Kursumwandlung zum Magnetkompakurs nicht vergessen !  <-- ');
  REPEAT UNTIL KEYPRESSED; CH := READKEY;
END;







PROCEDURE tittel;
VAR ober  : INTEGER;
    ch    : STRING;

BEGIN
   CLRSCR; TEXTBACKGROUND (4); TEXTCOLOR (6);                        highvideo;
   WRITE (' ****************************************************************************** ');
   WRITE (' * Navigation nach Gestirnen von Mike Stefanski,         DF2IAX, Version 2004 * ');
   WRITE (' ****************************************************************************** ');
   WRITELN;   TEXTBACKGROUND (0);  TEXTCOLOR (7);

   WRITELN (' Zur Berechnung der:      - Bildpunkte aller Navigationsgestirne ');
   WRITELN ('                          - Hc fr den gegiten Schiffsort');
   WRITELN ('                          - Differenz (Sextantwinkel+Gb)-Hc');
   WRITELN ('                          - Standlinie aus einer Gestirnsmessung');
   WRITELN ('                          - Position aus zwei Gestirnsmessungen');
   WRITELN ('                          - Entfernung und des Kurses zum Zielhafen');
   WRITELN;                lowvideo;
   WRITELN ('      Berechnungsgrundlage ist das Hhenverfahren nach Marc St. Hilaire. ');
   WRITELN ('      Beobachtete Mondhhe >18, bei Sonne, Mond, Sterne Hhe > 14 !');
   WRITELN ('      Ansonsten ist mit greren Ungenauigkeiten zu rechnen !');
   WRITELN (' ');
   WRITELN (' Gradeingaben: Grad Minuten.Zehntel (z.B. 8 22,5 E  entspricht -8 22.5 )');
   WRITELN ('               stliche Lngen und sdliche Breiten negativ eingeben !');
   WRITELN;
   WRITELN;
   TEXTCOLOR (12);       HIGHVIDEO;
   WRITELN ('  [1] U-Sonne    [2] U-Mond      [3] O-Mond     [4] Planeten     [5] Sterne');

   WRITE   ('  [6] Position   [7] Standlinien versegeln      [8] Zielkurs     [E] Ende');
   GOTOXY (67,24);
   TEXTCOLOR (14);
   WRITE   ('Wahl :  ');
   eingabe (ch);

   IF ch='1' THEN sonne;
   IF (ch ='2') OR (ch='3') THEN BEGIN
                                   IF ch='2' THEN ober:=0;
                                   IF ch='3' THEN ober:=1;
                                   Mond (ober);
                                 END;
   IF ch = '4' THEN wandelstern;
   IF ch=  '5' THEN STERN;
   IF (ch ='6') AND (standlinienzaehler >1) THEN POSITION;
   IF (ch ='6') AND (standlinienzaehler <2) THEN WRITE (chr(7));
   IF (ch ='7') AND (standlinienzaehler >0) THEN versegeln;
   IF (ch ='7') AND (standlinienzaehler <1) THEN WRITE (chr(7));
   IF (ch ='8') THEN zielkurs;
   IF (ch = 'e') OR (ch='E') THEN hauptmenu := FALSE;

   lowvideo;                TEXTCOLOR(7);
END;




BEGIN
  sternelesen;
  positionberechnet := FALSE;
  hauptmenu := TRUE;
  REPEAT
    tittel;
  UNTIL hauptmenu = FALSE;
  writeln;
  textcolor (7);
  clrscr;
  WRITELN
  ('Programmfehler, Verbesserungsvorschlge oder hnliches bitte mir melden:');
  writeln;
  writeln ('  Mike Stefanski, Im Gsselgarten 11, 76275 Ettlingen');
  writeln ('  Email: df2iax@gmx.net         URL: http://www.qsl.net/df2iax');
  writeln;
  writeln ('Dieses Programm darf jeder frei kopien, weitergeben und zum privaten Segel-');
  writeln ('sport nutzen! Ich verbiete aber, mit meinem Programm auf irgend eine Art');
  writeln ('und Weise Profit zu erwirtschaften !!!');

   WRITELN;
   WRITELN (' Hier noch einige Quellenangaben:');
   WRITELN (' Algorithmen fr Sonnen-, Mond und Planetenbildpunkte sowie Aries nach: ');
   WRITELN (' Montenbruck/Pfleger, Astronomie mit dem PC. Gb-Berechnung nach Albrecht');
   WRITELN (' (aus: Bobby Schenk, Yachtnavigation)');
   WRITELN (' Fixsternpositionen werden mittels des Kumm-Algorithmus berechnet');
   WRITELN (' (aus: bungsheft Navigation der Seeschule Hamburg).');
   WRITELN (' Positionsberechnung, Versegelung und Zielkurs sind von mir selbst entwickelt');
   WRITELN (' worden.');
   WRITELN;
   dateienda;
END.

