(*-----------------------------------------------------------------------*)
(* Unit SPHLIB: spherical astronomy                                      *)
(*-----------------------------------------------------------------------*)


{$N+,E+}       {Coprozessor verwenden, wenn nicht da emulieren !}
{$G-}          {Code erzeugen fuer 8086 CPU}


UNIT SPHLIB;

INTERFACE

  USES MATLIB, PNULIB;

  PROCEDURE ABERRAT  ( T: extended; VAR VX,VY,VZ: extended );
  PROCEDURE APPARENT ( PNMAT: extended33; VX,VY,VZ: extended; VAR RA,DEC: extended );
  PROCEDURE ECLEQU   ( T: extended; VAR X,Y,Z: extended );
  PROCEDURE EQUECL   ( T: extended; VAR X,Y,Z: extended );
  PROCEDURE EQUSTD   ( RA0,DEC0,RA,DEC: extended; VAR XX,YY: extended );
  PROCEDURE GAUSVEC  ( LAN,INC,AOP: extended; VAR PQR: extended33 );
  PROCEDURE ORBECL   ( XX,YY:extended;PQR:  extended33;  VAR X,Y,Z:extended );
  PROCEDURE SITE     ( PHI: extended; VAR RCPHI,RSPHI: extended );
  PROCEDURE STDEQU   ( RA0,DEC0,XX,YY: extended; VAR RA,DEC: extended );

IMPLEMENTATION

  (*$I \SPHERIC\SHPERIC.PAS  *)

END.
